/************************************************/
/*                                              */
/* Copyright (C) 1997 Michael Radchenko         */
/* Portions Copyright (C) 2009 MarinovSoft      */
/*                                              */
/************************************************/
#define Uses_TDialog
#define Uses_TRect
#define Uses_TStaticText
#define Uses_TButton
#define Uses_TProgram
#define Uses_TDeskTop
#define Uses_TScrollBar
#define Uses_TScroller
#define Uses_TView
#define Uses_TMsgBox
#define Uses_TPalette
#include <tv.h>
#include <string.h>
#include <stdlib.h>
#include "appwin.h"

//#include "growview.h"
TProgressDialog::TProgressDialog(const char *ATitle) :
   TDialog(TRect(0, 0, 40, 9), ATitle),
   TWindowInit(&TProgressDialog::initFrame)
{
   options |= ofCentered;
   TRect       R  = TRect(2, 2, 38, 3);
   TStaticText *T = new TStaticText(R, "     Current operation progress       ");
   CurrentText = T;
   insert(CurrentText);
   R   = TRect(2, 4, 38, 5);
   GV1 = new TGrowView(R, 100);
   insert(GV1);
   R = TRect(0, 6, 12, 8);
   TButton *B = new TButton(R, "~C~ancel", cmCancel, 1);
   B->options |= ofCenterX;
   insert(B);
}

void TProgressDialog::update(long val)
{
   GV1->update(val);
}

/***************************************************************************/
//void TProgressDialog::SetCurrentText(char *AText)
//{
//   CurrentText->text = '\3'+AText;
//   CurrentText->draw();
//}
/***************************************************************************/
//void TProgressDialog::SetTotalText(char *AText)
//{
//   TotalText->text = '\3'+AText;
//   TotalText->draw();
//}
/***************************************************************************/
TColorText::TColorText(TRect& Bounds, TScrollBar *aHScrollBar, TScrollBar *aVScrollBar) :
   TScroller(Bounds, aHScrollBar, aVScrollBar)
{
   Color      = 23;
   LinesCount = 0;
   FirstLine  = 1;
   for(short int i = 0; i != MaxLinesCount - 1; i++)
   {
       StrBuf[i][0] = 0;
   }
};
/***************************************************************************/
void TColorText::writeLineAt(short int LineNumber, char *S)
{
//      int Value;
//      int StartLine;
   if(LineNumber == -1)
   {
      LineNumber = LinesCount;
   }
   strcpy(StrBuf[LineNumber], S);
   if(LineNumber > LinesCount)
   {
      for(short int i = LinesCount + 1; i != LineNumber; i++)
      {
         strcpy(StrBuf[i], "");
      }
      LinesCount = LineNumber;
   }
   vScrollBar->setParams(LineNumber, 1, LinesCount, size.y, 1);
   draw();
};
/***************************************************************************/
void TColorText::writeLine(char *S)
{
   if(LinesCount > MaxLinesCount)
   {
      for(short int i = 2; i <= MaxLinesCount; i++)
      {
         strcpy(StrBuf[i - 1], StrBuf[i]);
      }
      strcpy(StrBuf[MaxLinesCount], S);
      draw();
      return;
   }
   LinesCount++;
   writeLineAt(LinesCount, S);
};
/***************************************************************************/
void TColorText::FillBuf(char *S, TDrawBuffer& Buf)
{
   unsigned short OldColor;
   unsigned short Len;
   unsigned short j;
   char S1[255];

   unsigned short XPos = 0;

   Buf.moveChar(0, ' ', Color, size.x);
   OldColor = Color;

   Len = strlen(S);
//      strcpy(S1,"");
//      strcpy(S1,S);
//      Buf.moveStr(XPos,S1,Color);

   for(unsigned short i = 0; i < Len; i++)
   {
//             strcpy(S1,"");
      for(j = i; ((S[j] != '|') && (j <= Len)); j++)
         {
         }
//             movmem(&S[i],&S1[1],j-i);S1[j-i]=0;
      strncpy(S1, S + i, j - i);
      S1[j - i] = 0;
      Buf.moveStr(XPos, S1, Color);
      XPos += j - i;
      i = j + 1;
      for(j = i; ((S[j] != '|') && (j <= Len)); j++)
      {
      }
//             movmem(&S[i],&S1[1],j-i);S1[j-i]=0;
      strncpy(S1, S + i, j - i);
      S1[j - i] = 0;
      i = j;
      if(j < Len)
      {
         if(strlen(S1) == 0)
         {
            Buf.moveStr(XPos, "|", Color);
            XPos++;
         }
         else
         {
            Color = atoi(S1);
         }
      }
   }
   Color = OldColor;
}

/***************************************************************************/
void TColorText::calcBounds(TRect& Bounds, TPoint D)
{
   size.x += D.x;
   size.y += D.y;
   TScroller::calcBounds(Bounds, D);
}

/***************************************************************************/
#define cpInfoWinPalette    "\08\09\10\11\12\13\14\15\08\09\10\13\32\30\26\31"
/***************************************************************************/
TPalette& TColorText::getPalette() const
{
   static TPalette palette(cpInfoWinPalette, sizeof(cpInfoWinPalette) - 1);
   return(palette);
}

/***************************************************************************/
void TColorText::draw()
{
   short int StartLine;
   short int value;
   TDrawBuffer Buf;

   value = vScrollBar->value;
   StartLine = max(1, value - size.y + 1);
   FirstLine = StartLine;
   for(short int i = 0; i < size.y; i++)
   {
      FillBuf(StrBuf[FirstLine + i], Buf);
      writeBuf(0, i, size.x, 1, Buf);
   }
}

/***************************************************************************/
static short int winNumber = 0;
TInfoWindow::TInfoWindow(char *titul) :
//TWindow(TProgram::deskTop->getExtent(), strcat("Reading file ",SFileName), winNumber++ ),
//TWindow(TRect(0,0,80,23), strcat("Reading file ",SFileName), winNumber++ ),
//TWindow(TRect(0,0,80,23), titul, winNumber++ ),
//TWindow(Bounds, titul, winNumber++ ),
   TWindow(TProgram::deskTop->getExtent(), titul, winNumber++),
   TWindowInit(&TInfoWindow::initFrame)
{
   TScrollBar *ScrollBar = standardScrollBar(sbVertical | sbHandleKeyboard);

   flags &= ~(wfZoom | wfGrow | wfMove);
   ScrollBar->options |= ofPostProcess;
   //insert(ScrollBar);
   TRect Bounds(getExtent());
   Bounds.grow(-1, -1);
   ScreenText = new TColorText(Bounds, NULL, ScrollBar);
   insert(ScreenText);

//    TRect r = getClipRect();
//    r.grow(-1, -1);
//    ScreenText = new TColorText( r,
//                               standardScrollBar(sbHorizontal | sbHandleKeyboard),
//                               standardScrollBar(sbVertical | sbHandleKeyboard)
//                             );
//    insert(ScreenText);
}

void TInfoWindow::draw()
{
   TWindow::draw();
   //ScreenText->draw();
}

short int TInfoWindow::GetLinesCount()
{
   return(ScreenText->LinesCount);
}

void TInfoWindow::writeLineAt(short int LineNumber, char *S)
{
   ScreenText->writeLineAt(LineNumber, S);
}

void TInfoWindow::writeLine(char *S)
{
   ScreenText->writeLine(S);
}

//TInfoWindow::~TInfoWindow()
//{
//      TWindow::~TWindow();
//      delete ScreenText;
//}
